#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <math.h>
#include <time.h>
#include <conio.h>

#define MAX(x,y) ((x)<(y) ? (y) : (x))

//------------------------------------------------------------------------------
//  ESTRUTURAS PRINCIPAIS           
//------------------------------------------------------------------------------

struct aulas {
    char * dep; // Sigla do departamento
    int codigo; // Cdigo da aula
    int turma; // Turma
    char flag; // Aula terica ou prtica (t ou p)
    int flag2[3];
    int demanda; // Demanda
    int dia[3]; // Dia da semana
    int horini[3]; // Hora de inicio
    int horfim[3]; // Hora de fim
    int horaini[3]; // Horrio da semana de inicio
    int horafim[3]; // Horrio da semana de fim
};

//------------------------------------------------------------------------------
//DECLARAO DAS FUNES
//------------------------------------------------------------------------------

int sol_viavel(int nsalas,int nhorarios,aulas aula[100],int **tabelaSstar ,int *capacidade);
int calcula_fo_ini(int nsalas,int nhorarios,int pociosidade,int tabelaS0[91][8],aulas aula[100],int *capacidade,int pexcesso);
void imprime_solstar(int nsalas,int nhorarios,int **tabelaSstar ,int inviabilidade,int foSstar,aulas aula[100],int *capacidade,int **p);
int menu();
int le_entrada(aulas aula[100],int *capacidade,int **p);
int sol_inicial(int nsalas,int nhorarios,int tabelaS0[91][8],aulas aula[100],int *capacidade,int naula,int pociosidade,int pexcesso);
char* legendadep (int valor);
int legendahor (int hora, int dia);
double randomico(int min, int max);
void imprime_sol(int nsalas,int nhorarios,int tabelaS0[91][8],int fo);
int SA(int nsalas,int nhorarios,int pociosidade,int tabelaS0[91][8],aulas aula[100],int **tabelaSstar ,int *capacidade,int fo,int pexcesso,int **p,int temp_inicial,double alfa,int itermax,int SAmax);
int calcula_foS(int nsalas,int nhorarios,int pociosidade,aulas aula[100],int tabelaS[91][8] ,int *capacidade,int pexcesso,int **p);
int calcula_foSstar(int nsalas,int nhorarios,int pociosidade,aulas aula[100],int **tabelaSstar ,int *capacidade,int pexcesso,int **p);
int ler_pociosidade();
int ler_pexcesso();
int *cria_vetor(int tam);
double calcula_delta(int tabelaS0[91][8],int *capacidade, int i1, int i2,int j1, int j2,int pexcesso,int pociosidade,aulas aula[100]);
double temperatura_inicial(int nhorarios,int nsalas,int tabelaS0[91][8],int **p,double beta,double gamma,int SAmax,int *capacidade,int pexcesso,int pocisidade,aulas aula[100]);
int **cria_matriz(int nlinhas, int ncolunas);
int calcula_penalidade(int tabelaS0[91][8],int *capacidade,int i,int j,int pexcesso,int pociosidade,aulas aula[100]);

//------------------------------------------------------------------------------
//  Programa Principal     
//------------------------------------------------------------------------------
void main() {
    int nsalas = 7; // nmero de salas
    int nhorarios = 90; // nmero de horrios
    int pociosidade; // penalidade por possuir cartieras vazias
    int pexcesso; // penalidade por exceder a capacidade da sala
    int tabelaS0[91][8]; // tabela de alocao de salas - Soluo corrente
    int * * tabelaSstar; // tabela de alocao de salas - Melhor Soluo obtida at ento
    aulas aula[100];
    int * capacidade; // armazena a capacidade das salas
    int seleciona;
    int naula;
    int fo;
    int * * p; // vetor de penalidades
    p = cria_matriz(91, 8);
    tabelaSstar = cria_matriz(91, 8);
    capacidade = cria_vetor(nhorarios);
    clock_t inicio_CPU,fim_CPU;
    double alfa = 0.99;         // coeficiente de resfriamento
    int itermax= 1000;
    int SAmax =500;           // numero maximo de iteracoes em uma dada temperatura


    printf("--------------------------------------------------------------------------------");
    gotoxy(28,2);
    printf("PROBLEMA DE ALOCACAO DE SALAS\n");
    gotoxy(27,3);
    printf("- USANDO SIMULATED ANNEALING -\n");
    printf("--------------------------------------------------------------------------------");
    do {
      seleciona = menu();
      if (seleciona == 1) {

        printf("Solucao inicial aleatoria:\n");
        srand(1000); // pega 1000 como semente

        naula = le_entrada(aula, capacidade, p);
        pociosidade = ler_pociosidade();
        pexcesso = ler_pexcesso();
        fo = sol_inicial(nsalas, nhorarios, tabelaS0, aula, capacidade, naula,pociosidade, pexcesso);
        imprime_sol(nsalas, nhorarios, tabelaS0, fo);
        printf("Funo Objetivo= %d\n", fo);
      }
      else {
        if (seleciona == 2) {
          /* Simulated Annealing */

          if (fo != 0) {
            int temp_inicial = temperatura_inicial(nhorarios, nsalas, tabelaS0,p,1.1,alfa,SAmax,capacidade,pexcesso, pociosidade, aula);
            inicio_CPU = clock();
            int foSstar = SA(nsalas, nhorarios, pociosidade, tabelaS0, aula,tabelaSstar, capacidade, fo, pexcesso,p,temp_inicial,alfa,itermax,SAmax);
            fim_CPU = clock();
            int inviabilidade = sol_viavel(nsalas, nhorarios, aula, tabelaSstar,capacidade);
            imprime_solstar(nsalas, nhorarios, tabelaSstar, inviabilidade,foSstar,aula, capacidade, p);
            printf("\n\nFuno Objetivo= %d\n", foSstar);
            printf("Tempo de CPU = %f segundos\n",(fim_CPU - inicio_CPU)/CLK_TCK);
          }
          else {
            printf("\n ----- Gere uma solucao inicial -------\n");
            getchar();
          }
        }
      }                                                       //619838
    } while (seleciona != 0);
}


//------------------------------------------------------------------------------
//  Funo Menu     
//------------------------------------------------------------------------------

  int menu() {
    int escolha;

    do {
      printf("--------------------------------------------------------------------------------");
      printf("         0. Sair \n");
      printf("         1. Gere solucao inicial \n");
      printf("         2. Simulated Annealing \n");
      printf("         Escolha: ");
      scanf("%d", & escolha);
      printf("--------------------------------------------------------------------------------");
    }
    while (escolha < 0 || escolha > 2);
    return escolha;
  }
//------------------------------------------------------------------------------
//  Funo legenda dos departamentos 
//------------------------------------------------------------------------------

  char * legendadep(int digito) {
    char * saida;
    switch (digito) {
      case 1:
        saida = "MTM";
        break;

      case 2:
        saida = "QUI";
        break;

      case 3:
        saida = "FIS";
        break;

      case 4:
        saida = "CIC";
        break;

      case 5:
        saida = "COM";
        break;

      case 6:
        saida = "CBI";
        break;
    }
    return saida;
  }

//------------------------------------------------------------------------------
//  Funo legenda dos horrios         
//------------------------------------------------------------------------------

  int legendahor(int hora, int dia) {
    int saida;

    if ( (hora == 450) && (dia == 2)) {saida = 1;}
    if ( (hora == 500) && (dia == 2)) {saida = 2;}
    if ( (hora == 570) && (dia == 2)) {saida = 3;}
    if ( (hora == 620) && (dia == 2)) {saida = 4;}
    if ( (hora == 680) && (dia == 2)) {saida = 5;}
    if ( (hora == 730) && (dia == 2)) {saida = 6;}
    if ( (hora == 780) && (dia == 2)) {saida = 7;}
    if ( (hora == 830) && (dia == 2)) {saida = 8;}
    if ( (hora == 900) && (dia == 2)) {saida = 9;}
    if ( (hora == 950) && (dia == 2)) {saida = 10;}
    if ( (hora == 1010) && (dia == 2)) {saida = 11;}
    if ( (hora == 1060) && (dia == 2)) {saida = 12;}
    if ( (hora == 1110) && (dia == 2)) {saida = 13;}
    if ( (hora == 1140) && (dia == 2)) {saida = 14;}
    if ( (hora == 1190) && (dia == 2)) {saida = 15;}
    if ( (hora == 1260) && (dia == 2)) {saida = 16;}
    if ( (hora == 1310) && (dia == 2)) {saida = 17;}
    if ( (hora == 450) && (dia == 3)) {saida = 18;}
    if ( (hora == 500) && (dia == 3)) {saida = 19;}
    if ( (hora == 570) && (dia == 3)) {saida = 20;}
    if ( (hora == 620) && (dia == 3)) {saida = 21;}
    if ( (hora == 680) && (dia == 3)) {saida = 22;}
    if ( (hora == 730) && (dia == 3)) {saida = 23;}
    if ( (hora == 780) && (dia == 3)) {saida = 24;}
    if ( (hora == 830) && (dia == 3)) {saida = 25;}
    if ( (hora == 900) && (dia == 3)) {saida = 26;}
    if ( (hora == 950) && (dia == 3)) {saida = 27;}
    if ( (hora == 1010) && (dia == 3)) {saida = 28;}
    if ( (hora == 1060) && (dia == 3)) {saida = 29;}
    if ( (hora == 1110) && (dia == 3)) {saida = 30;}
    if ( (hora == 1140) && (dia == 3)) {saida = 31;}
    if ( (hora == 1190) && (dia == 3)) {saida = 32;}
    if ( (hora == 1260) && (dia == 3)) {saida = 33;}
    if ( (hora == 1310) && (dia == 3)) {saida = 34;}
    if ( (hora == 450) && (dia == 4)) {saida = 35;}
    if ( (hora == 500) && (dia == 4)) {saida = 36;}
    if ( (hora == 570) && (dia == 4)) {saida = 37;}
    if ( (hora == 620) && (dia == 4)) {saida = 38;}
    if ( (hora == 680) && (dia == 4)) {saida = 39;}
    if ( (hora == 730) && (dia == 4)) {saida = 40;}
    if ( (hora == 780) && (dia == 4)) {saida = 41;}
    if ( (hora == 830) && (dia == 4)) {saida = 42;}
    if ( (hora == 900) && (dia == 4)) {saida = 43;}
    if ( (hora == 950) && (dia == 4)) {saida = 44;}
    if ( (hora == 1010) && (dia == 4)) {saida = 45;}
    if ( (hora == 1060) && (dia == 4)) {saida = 46;}
    if ( (hora == 1110) && (dia == 4)) {saida = 47;}
    if ( (hora == 1140) && (dia == 4)) {saida = 48;}
    if ( (hora == 1190) && (dia == 4)) {saida = 49;}
    if ( (hora == 1260) && (dia == 4)) {saida = 50;}
    if ( (hora == 1310) && (dia == 4)) {saida = 51;}
    if ( (hora == 450) && (dia == 5)) {saida = 52;}
    if ( (hora == 500) && (dia == 5)) {saida = 53;}
    if ( (hora == 570) && (dia == 5)) {saida = 54;}
    if ( (hora == 620) && (dia == 5)) {saida = 55;}
    if ( (hora == 680) && (dia == 5)) {saida = 56;}
    if ( (hora == 730) && (dia == 5)) {saida = 57;}
    if ( (hora == 780) && (dia == 5)) {saida = 58;}
    if ( (hora == 830) && (dia == 5)) {saida = 59;}
    if ( (hora == 900) && (dia == 5)) {saida = 60;}
    if ( (hora == 950) && (dia == 5)) {saida = 61;}
    if ( (hora == 1010) && (dia == 5)) {saida = 62;}
    if ( (hora == 1060) && (dia == 5)) {saida = 63;}
    if ( (hora == 1110) && (dia == 5)) {saida = 64;}
    if ( (hora == 1140) && (dia == 5)) {saida = 65;}
    if ( (hora == 1190) && (dia == 5)) {saida = 66;}
    if ( (hora == 1260) && (dia == 5)) {saida = 67;}
    if ( (hora == 1310) && (dia == 5)) {saida = 68;}
    if ( (hora == 450) && (dia == 6)) {saida = 69;}
    if ( (hora == 500) && (dia == 6)) {saida = 70;}
    if ( (hora == 570) && (dia == 6)) {saida = 71;}
    if ( (hora == 620) && (dia == 6)) {saida = 72;}
    if ( (hora == 680) && (dia == 6)) {saida = 73;}
    if ( (hora == 730) && (dia == 6)) {saida = 74;}
    if ( (hora == 780) && (dia == 6)) {saida = 75;}
    if ( (hora == 830) && (dia == 6)) {saida = 76;}
    if ( (hora == 900) && (dia == 6)) {saida = 77;}
    if ( (hora == 950) && (dia == 6)) {saida = 78;}
    if ( (hora == 1010) && (dia == 6)) {saida = 79;}
    if ( (hora == 1060) && (dia == 6)) {saida = 80;}
    if ( (hora == 1110) && (dia == 6)) {saida = 81;}
    if ( (hora == 1140) && (dia == 6)) {saida = 82;}
    if ( (hora == 1190) && (dia == 6)) { saida = 83;}
    if ( (hora == 1260) && (dia == 6)) {saida = 84; }
    if ( (hora == 1310) && (dia == 6)) {saida = 85;}
    if ( (hora == 450) && (dia == 7)) {saida = 86; }
    if ( (hora == 500) && (dia == 7)) {saida = 87;}
    if ( (hora == 570) && (dia == 7)) {saida = 88;}
    if ( (hora == 620) && (dia == 7)) {saida = 89;}
    if ( (hora == 680) && (dia == 7)) {saida = 90;}

    return saida;
  }

//------------------------------------------------------------------------------
//  Funo le dados de entrada
//------------------------------------------------------------------------------

int le_entrada(aulas aula[100],int *capacidade,int **p)
{
  int naula;
  int i, k, valor;
  int codigo, turma, dia;
  char flag;
  char* dep;
  int h1, m1, h2, m2;

  FILE *cap;
	cap = fopen("capacidade.txt", "r");
	if(!cap)
	{
	  printf("\n\nArquivo capacidade.txt nao pode ser aberto.\n");
	  getchar();
	  exit(1);
	}

  FILE *dem;
	dem = fopen("demanda.txt", "r");
	if(!dem)
	{
	  printf("\n\nArquivo demanda.txt nao pode ser aberto.\n");
	  getchar();
	  exit(1);
	}


  FILE *hor;
	hor = fopen("horario.txt", "r");
	if(!hor)
	{
	  printf("\n\nArquivo horario.txt nao pode ser aberto.\n");
	  getchar();
	  exit(1);
	}

  FILE *dis;
	dis = fopen("disciplina.txt", "w");
	if(!dis)
	{
	  printf("\n\nArquivo disciplina.txt nao pode ser aberto.\n");
	  getchar();
	  exit(1);
	}


  i=0;
  while (!feof(cap))      // no chegou o fim do arquivo
  {
    fscanf(cap, "%d|%d|\n", &i, &valor);    // l do arquivo capacidade o valor da posio (i) e o valor da capacidade (valor)
    capacidade[i] = valor;
  }
  i=0;
  while (!feof(dem))
  {
    i++;
    fscanf(dem, "%d|%d|%d|%d|\n", &valor, &aula[i].codigo,         //valor  o cdigo do departamento
                                  &aula[i].turma, &aula[i].demanda);
    aula[i].dep = legendadep (valor);
    for (k=0; k<=2; k++)
    {
      aula[i].dia[k]=0;
      aula[i].horini[k]=0;
      aula[i].horfim[k]=0;
      aula[i].horaini[k]=0;
      aula[i].horafim[k]=0;
      aula[i].flag2[k] =0;
    }
  }
  naula= i;
  i=0;
  while (!feof(hor))
  {                                                   //  valor cdigo do departamento
    i++;
    fscanf(hor, "%d|%d|%d|%c|%d|%d:%d|%d:%d|\n", &valor, &codigo, &turma, &flag,
                                                 &dia, &h1, &m1, &h2, &m2);          
    m1+= h1*60;
    m2+= h2*60;
    dep = legendadep(valor);
    for (i=1; i<=naula; i++)
    {
       if ((codigo== aula[i].codigo) && (turma== aula[i].turma) &&
            (dep== aula[i].dep))
       {
           aula[i].flag= flag;
           for(k=1; k<=2; k++)
           {
               if ((aula[i].dia[k]== 0) && (aula[i].dia[k-1]!= dia))
               {
                   aula[i].dia[k]= dia;
               }
               if (aula[i].dia[k]== dia)
               {
                   if (aula[i].horini[k]==0)
                   {
                       aula[i].horini[k]= m1;
                       aula[i].horfim[k]= m1;
                   }
                   else
                   {
                      if (m1<aula[i].horini[k])
                      {
                          aula[i].horini[k]= m1;
                      }
                      else
                      {
                          aula[i].horfim[k]= m1;
                      }
                   }
               }
           }
           break;
       }
    }
    for (i=1; i<=naula; i++)
    {
        for(k=1; k<=2; k++)
        {
           if (aula[i].dia[k]!= 0)
           {
              aula[i].horaini[k]= legendahor(aula[i].horini[k], aula[i].dia[k]);
              aula[i].horafim[k]= legendahor(aula[i].horfim[k], aula[i].dia[k]);
           }
        }

    }
  }
  fprintf(dis,"\n\n----------------------------------------------------------------------------\n");
  fprintf(dis,"| N. | Disciplina | Turma | Demanda | Horaini | Horafim | Horaini | Horafim |\n");
  fprintf(dis,"----------------------------------------------------------------------------\n");
  for (i=1; i<=naula; i++)
  {
        fprintf(dis,"| %2.2d |   %s%d   |  %2.2d   |   %2.2d    | ", i, aula[i].dep, aula[i].codigo,
                     aula[i].turma, aula[i].demanda);
        for(k=1; k<=2; k++)
        {
           fprintf(dis,"  %2.2d    |   %2.2d    | ", aula[i].horaini[k], aula[i].horafim[k]);
        }
        fprintf(dis,"\n");
        fprintf(dis,"----------------------------------------------------------------------------\n");
  }
  fclose(dis);
  fclose(hor);
  fclose(cap);
  fclose(dem);
  return naula;
}

//------------------------------------------------------------------------------
//  Funo gera nmero aleatrio
//------------------------------------------------------------------------------

double randomico(int min, int max)
{
  return ((double) (random(max-min) + min));
}


//------------------------------------------------------------------------------
//  Funo gera soluo inicial aleatria
//------------------------------------------------------------------------------

int sol_inicial(int nsalas,int nhorarios,int tabelaS0[91][8],aulas aula[100],int *capacidade,int naula,int pociosidade,int pexcesso)
{
     int fo;
     int n;         // sala escolhida
     int m, ms;     // horrio da semana
     int i;         // aula
     int k= 1;      // horrio da aula
     int iter= 0;   // numero de tentativas de alocar uma aula
     int aux;

     for (n=0; n<=nsalas; n++)
     {                                               // 154,2       461680
        for (m=0; m<=nhorarios; m++)
        {
           tabelaS0[m][n]= 0;
        }
     }
     // escolhe uma aula
     for (i=1; i<= naula; i++)
     {
       for (k=1; k<= 2; k++)
       {
         // aleatoriamente escolhe uma sala
         aux= randomico(1, (nsalas+1));
         n= aux;
         iter=0;
         do
         {
            m= aula[i].horaini[k];
            ms= aula[i].horafim[k];
               if ((tabelaS0[m][n]== 0) && (tabelaS0[ms][n]== 0))
               {
                  tabelaS0[m][n]= i;
                  tabelaS0[ms][n]= i;
                  if ((ms-m)>1) {tabelaS0[ms-1][n]=i;}
                  if ((ms-m)>2) {tabelaS0[m+1][n]=i;}
                  aula[i].flag2[k]= 1;
                  break;
               }
               else
               {
                  aux= randomico(1, (nsalas+1));
                  n= aux;
                  if (iter>15)
                  {
                     tabelaS0[m][0]= i;
                     tabelaS0[ms][0]= i;
                     tabelaS0[ms-1][0]= i;
                     aula[i].flag2[k]= 1;
                     break;
                  }
                  iter++;
               }
          }while (aula[i].flag2[k]== 0);
       }
     }
     fo = calcula_fo_ini(nsalas,nhorarios,pociosidade,tabelaS0,aula,capacidade,pexcesso);
     return fo;
}

//------------------------------------------------------------------------------
//  Funo imprime soluo inicial
//------------------------------------------------------------------------------

void imprime_sol(int nsalas,int nhorarios,int tabelaS0[91][8],int fo)
{
    int m, n;

    FILE *sol;
	sol = fopen("solucao.txt", "w");
	if(!sol)
	{
	  printf("\n\nArquivo solucao.txt nao pode ser criado.\n");
	  getchar();
	  exit(1);
	}
    fprintf (sol, "\nFuno Objetivo: %d\n\n\n", fo);
    fprintf (sol, "_________________________________________________\n");
    fprintf (sol, "|H-S\t| sv | 01 | 02 | 03 | 04 | 05 | 06 | 07 |\n");
    fprintf (sol, "_________________________________________________\n");
    for (m= 1; m<=nhorarios; m++)
    {
        fprintf (sol, "| %d\t|", m);
        for (n=0; n<=nsalas; n++)
        {
           fprintf (sol, " %2.2d |", tabelaS0[m][n]);
        }
        fprintf (sol, "\n");
    }
    fprintf (sol, "_________________________________________________\n");

    fclose(sol);
}

//------------------------------------------------------------------------------
//  Funo imprime soluo final
//------------------------------------------------------------------------------

void imprime_solstar(int nsalas,int nhorarios,int **tabelaSstar ,int inviabilidade,int foSstar,aulas aula[100],int *capacidade,int **p)
{
    int m, n,i;

    FILE *sol;
	sol = fopen("solucaof.txt", "w");
	if(!sol)
	{
	  printf("\n\nArquivo solucao.txt nao pode ser criado.\n");
	  getchar();
	  exit(1);
	}
    fprintf (sol, "\nFuno Objetivo: %d\n", foSstar);
    fprintf (sol, "Inviabilidades: %d\n", inviabilidade);
    fprintf (sol, "________________________________________________________\n");
    fprintf (sol, "|H-S\t| sv  | 01  | 02  | 03  | 04  | 05  | 06  | 07  |\n");
    fprintf (sol, "________________________________________________________\n");
    for (m= 1; m<=nhorarios; m++)
    {
        fprintf (sol, "| %d\t|", m);

        for (n=0; n<=nsalas; n++)
        {
           i = tabelaSstar[m][n];

           if (aula[i].demanda > capacidade[n]) {fprintf (sol, " %2.2d* |", i);}
           else {fprintf (sol, " %3.2d |", i); }

        }
        fprintf (sol, "\n");
    }
    fprintf (sol, "_________________________________________________\n");

    fclose(sol);
}

//------------------------------------------------------------------------------
//  Funo le penalidade por ociosidade
//------------------------------------------------------------------------------
int ler_pociosidade()
{
        int pociosidade;
        int aux;

	FILE *pes;
	pes = fopen("peso.par", "r");
	if(!pes)
	{
	  printf("\n\nArquivo nsuica.par nao pode ser aberto.\n");
	  getchar();
	  exit(1);
	}
	fscanf(pes, "%d", &aux);
        fscanf(pes, "%d", &aux);
	pociosidade= aux;
        printf("Penalidade por ociosidade= %d\n",pociosidade);
	fclose(pes);
        return pociosidade;
}

//------------------------------------------------------------------------------
//  Funo le penalidade por excesso
//------------------------------------------------------------------------------

int ler_pexcesso()
{
        int pexcesso;
        int aux;

	FILE *pes;
	pes = fopen("peso.par", "r");
	if(!pes)
	{
	  printf("\n\nArquivo nsuica.par nao pode ser aberto.\n");
	  getchar();
	  exit(1);
	}

        fscanf(pes, "%d", &aux);
	pexcesso= aux;
        printf("Penalidade por excesso de capacidade= %d\n",pexcesso);
	fclose(pes);
        return pexcesso;
}
//------------------------------------------------------------------------------
//  Funo calcula funo objetivo inicial
//------------------------------------------------------------------------------

int calcula_fo_ini(int nsalas,int nhorarios,int pociosidade,int tabelaS0[91][8],aulas aula[100],int *capacidade,int pexcesso)
{
    int m, n;     // dimenses da tabelaS0 de alocao de salas
    int aux;
    int fo= 0;
    int penalidade;
    for (m= 1; m<=nhorarios; m++)
    {
        for (n=0; n<=nsalas; n++)
        {
            aux= tabelaS0[m][n];
            if (aula[aux].demanda> capacidade[n])
            {
                   penalidade = pexcesso*(aula[aux].demanda- capacidade[n]);
            }
            else
            {
                   penalidade = pociosidade*(capacidade[n]- aula[aux].demanda);
            }
            fo+= penalidade;
        }
     }
      return fo;
}

//------------------------------------------------------------------------------
//  Funo calcula FOS
//------------------------------------------------------------------------------

int calcula_foS(int nsalas,int nhorarios,int pociosidade,aulas aula[100],int tabelaS[91][8] ,int *capacidade,int pexcesso,int **p)
{
    int m, n;    // dimenses da tabelaS0 de alocao de salas
    int aux;

    int foS= 0;

    for (m= 1; m<=nhorarios; m++)
    {
        for (n=0; n<=nsalas; n++)
        {
            aux= tabelaS[m][n];
            if (aula[aux].demanda> capacidade[n])
            {
                    foS += pexcesso*(aula[aux].demanda- capacidade[n]);
            }
            else
            {                                                                                      
                    foS += pociosidade*(capacidade[n]- aula[aux].demanda);
            }
        }
    }
    return foS;
}

//------------------------------------------------------------------------------
//  Funo calcula FOSstar
//------------------------------------------------------------------------------

int calcula_foSstar(int nsalas,int nhorarios,int pociosidade,aulas aula[100],int **tabelaSstar ,int *capacidade,int pexcesso,int **p)
{
    int m, n;  // dimenses da tabelaS0 de alocao de salas
    int aux;

    int penalidade;
    int foSstar= 0;
    for (m= 1; m<=nhorarios; m++)
    {
        for (n=0; n<=nsalas; n++)
        {
            aux= tabelaSstar[m][n];
            if (aula[aux].demanda> capacidade[n])
            {
                   penalidade = pexcesso*(aula[aux].demanda- capacidade[n]);
            }
            else
            {
                   penalidade = pociosidade*(capacidade[n]- aula[aux].demanda);
            }
            p[m][n]= penalidade;
            foSstar+= penalidade;

        }
    }
    return foSstar;
}

//------------------------------------------------------------------------------
//  Funo Simulated Annealing
//------------------------------------------------------------------------------

int SA(int nsalas,int nhorarios,int pociosidade,int tabelaS0[91][8],aulas aula[100],int **tabelaSstar ,int *capacidade,int fo,int pexcesso,int **p,int temp_inicial,double alfa,int itermax,int SAmax)
{
    double temperatura;
    double temperatura_final = 0.01;
    int tabelaS[91][8];       // tabela de alocao de salas - Soluo
    double delta;              // variao da energia
    double x;                  // nmero randomico
    int m, n;                  // dimenses da tabela
    int iter;                  // nmero de iteraes
    int aux, i, j;             // contadores auxiliares
    int posicao[6];            // identifca aulas duplas
    int pare, pare1, pare2;    // para os loops quando no existe melhoras na fostar
    int foS;
    clock_t inicio_CPU,fim_CPU;


    inicio_CPU = clock();

    for (m= 1; m<=nhorarios; m++)
    {
        for (n=0; n<=nsalas; n++)
        {
            tabelaS[m][n]= tabelaS0[m][n];
            tabelaSstar [m][n]= tabelaS[m][n];
        }
    }

    int foSstar = calcula_foSstar(nsalas,nhorarios,pociosidade,aula,tabelaSstar,capacidade,pexcesso,p);
    temperatura= temp_inicial;

    pare2= 0;
    while (temperatura > temperatura_final)
    {
       iter = 0;
       pare1= 0;
       while (iter < SAmax) // enquanto o equilibrio termico nao for atingido
       {
          iter++;
	  // escolha um vizinho qualquer
          for (j=0; j<6; j++)
          {
              posicao[j]=0;     // limpa o vetor que identifica as aulas sequenciais
          }
          do
          {
             aux= randomico(0, (nsalas+1));
             n= aux;
             aux= randomico(1, (nhorarios+1));
             m= aux;
          }while (tabelaS[m][n]==0);

          j= 0;
          for (i= (m-3); i<=(m+3); i++)
          {
             if (tabelaS[m][n]== tabelaS[i][n])
             {
                posicao[j]= i;    // identifica as aulas sequenciais
                j++;
             }
          }

          pare= 0;
          do
          {
            aux= randomico(0, (nsalas+1));
            //printf("|");
            if (tabelaS[m][aux]== 0)
            {
               //printf(" %d\n", pare1);
               pare1++;
               pare2++;
               if (pare1 > (0.1*itermax))
               {
                   break;      // encerrar o SA quando ocorre mais de itermax iteraes sem melhora
               }
               if ((((tabelaS[(posicao[0])][n]!= 0) && (tabelaS[(posicao[0])][aux]==0)) ||(tabelaS[(posicao[0])][n]== 0))
                  && (((tabelaS[(posicao[1])][n]!= 0) && (tabelaS[(posicao[1])][aux]==0)) ||(tabelaS[(posicao[1])][n]== 0))
                  && (((tabelaS[(posicao[2])][n]!= 0) && (tabelaS[(posicao[2])][aux]==0)) ||(tabelaS[(posicao[2])][n]== 0))
                  && (((tabelaS[(posicao[3])][n]!= 0) && (tabelaS[(posicao[3])][aux]==0)) ||(tabelaS[(posicao[3])][n]== 0))
                  && (((tabelaS[(posicao[4])][n]!= 0) && (tabelaS[(posicao[4])][aux]==0)) ||(tabelaS[(posicao[4])][n]== 0))
                  && (((tabelaS[(posicao[5])][n]!= 0) && (tabelaS[(posicao[5])][aux]==0)) ||(tabelaS[(posicao[5])][n]== 0)))
               {
                  tabelaS[m][aux]= tabelaS[m][n];
                  tabelaS[m][n]= 0;
                  pare= 1;
                  for (j= 0; j<=5; j++)
                  {
                    if (tabelaS[(posicao[j])][n]!= 0)
                    {
                       tabelaS[(posicao[j])][aux]= tabelaS[(posicao[j])][n];
                       tabelaS[(posicao[j])][n]= 0;
                    }
                  }
               }
            }
          }while (pare!=1);

          foS = calcula_foS(nsalas,nhorarios,pociosidade,aula,tabelaS,capacidade,pexcesso,p);
          delta = foS - fo;
          if (delta<0)
          {
             fim_CPU = clock();
             printf("\n\nNovo vizinho funo objetivo: %d\n", foS);
             printf("Temperatura atual: %f\n", temperatura);
             printf("Numero de iteraes: %d\n", iter);
             printf("Tempo de CPU = %f segundos\n",(fim_CPU - inicio_CPU)/CLK_TCK);
             for (m= 1; m<=nhorarios; m++)
             {
                 for (n=0; n<=nsalas; n++)
                 {
                     tabelaS0[m][n]= tabelaS[m][n];
                 }
             }
             if (foS<foSstar)
             {
                 for (m= 1; m<=nhorarios; m++)
                 {
                     for (n=0; n<=nsalas; n++)
                     {
                         tabelaSstar[m][n]= tabelaS[m][n];
                     }
                 }
                 foSstar = calcula_foSstar(nsalas,nhorarios,pociosidade,aula,tabelaSstar,capacidade,pexcesso,p);
                 pare1=0;
                 pare2=0;
                 fim_CPU = clock();
                 printf("\n\nNova funo objetivo: %d\n", foSstar);
                 printf("Temperatura atual: %f\n", temperatura);
                 printf("Numero de iteraes: %d\n", iter);
                 printf("Tempo de CPU = %f segundos\n",(fim_CPU - inicio_CPU)/CLK_TCK);
             }
          }
          else
          {
             x= randomico(0,100000);
             x= x/100000;
             if (x < (exp(-delta/temperatura)))
             {
                foS = calcula_foS(nsalas,nhorarios,pociosidade,aula,tabelaS,capacidade,pexcesso,p);
                fim_CPU = clock();
                printf("\n\nNovo vizinho funo objetivo: %d\n", foS);
                printf("Temperatura atual: %f\n", temperatura);
                printf("Numero de iteraes: %d\n", iter);
                printf("Tempo de CPU = %f segundos\n",(fim_CPU - inicio_CPU)/CLK_TCK);
                for (m= 1; m<=nhorarios; m++)
                {
                    for (n=0; n<=nsalas; n++)
                    {
                      tabelaS0[m][n]= tabelaS[m][n];
                    }
                }
             }
          }
          for (m= 1; m<=nhorarios; m++)
          {
            for (n=0; n<=nsalas; n++)
            {
              tabelaS[m][n]= tabelaS0[m][n];
            }
          }
          fo = calcula_fo_ini(nsalas,nhorarios,pociosidade,tabelaS0,aula,capacidade,pexcesso);
          if (pare1> (0.1*itermax))
          {
             break;    // encerrar o SA quando ocorre mais de itermax iteraes sem melhora
          }
       }
       if (pare2> (itermax))
       {
          break;     // encerrar o SA quando ocorre mais de itermax iteraes sem melhora
       }
       temperatura = alfa*temperatura;
    }
    return foSstar;
}

//------------------------------------------------------------------------------
//  Funo confere soluo vivel
//------------------------------------------------------------------------------

int sol_viavel(int nsalas,int nhorarios,aulas aula[100],int **tabelaSstar ,int *capacidade)
{
  int i, m, n;

  int inviabilidade=0;
  printf("\n");
  for (n=0; n<=nsalas; n++)
  {
     for (m= 1; m<=nhorarios; m++)
     {
        i= tabelaSstar[m][n];
        if (aula[i].demanda> capacidade[n])
        {
           inviabilidade++;
           printf("%d - ",i);
        }
     }
  }
  printf("\nnumero de inviabilidades: %d \n", inviabilidade);
  return inviabilidade;
}
//------------------------------------------------------------------------------
//                           Funo Temperatura Inicial
//------------------------------------------------------------------------------

double temperatura_inicial(int nhorarios,int nsalas,int tabelaS0[91][8],int **p,double beta,double gamma,int SAmax,int *capacidade,int pexcesso,int pociosidade,aulas aula[100])

{
  int i1, i2,j1,j2, aux, iterT, aceitos;
  double temperatura, delta, fo;
  bool continua;

  temperatura = 20;
  continua = true;
  while (continua){
    aceitos = 0;
    iterT = 0;
    while (iterT < SAmax){
      iterT++;
      // Gere um vizinho qualquer
      i1 = random(nhorarios);
      j1 = random(nsalas);

      do{
        i2 = random(nhorarios);
        j2 = random(nsalas);
      } while ((i1 == i2) && (j1 == j2));


      double delta1 = calcula_delta(tabelaS0,capacidade,i1,i2,j1,j2,pexcesso,pociosidade,aula);

      // Faz o movimento

      aux = tabelaS0[i1][j1];
      tabelaS0[i1][j1] = tabelaS0[i2][j2];
      tabelaS0[i2][j2] = aux;

      double delta2 = calcula_delta(tabelaS0,capacidade,i2,i1,j2,j1,pexcesso,pociosidade,aula);
      delta = - delta1 + delta2;
      if (delta < 0){
         aceitos++;
      }
      else{
        float x = randomico(0,1);
        if (x < exp(-delta/temperatura)){
           aceitos++;
        }
      }
      // Desfaz o movimento
      aux = tabelaS0[i2][j2];
      tabelaS0[i2][j2] = tabelaS0[i1][j1];
      tabelaS0[i1][j1] = aux;
    }
    if (aceitos < gamma * SAmax){
      temperatura = beta * temperatura;
    }
    else
      continua = false;
  }
  return temperatura;
}


//------------------------------------------------------------------------------
//                           Funo Criar Vetor
//------------------------------------------------------------------------------

 int *cria_vetor(int tam)
{
  int *vetor;

  vetor = (int *) malloc(tam*sizeof(int));
  if (!vetor){
  	printf("Falta memoria para alocar o vetor de ponteiros");
    exit(1);
  }
  return vetor;
}


//------------------------------------------------------------------------------
//                           Funo Calcula Delta
//------------------------------------------------------------------------------

double calcula_delta(int tabelaS0[91][8],int *capacidade, int i1, int i2,int j1, int j2,int pexcesso,int pociosidade,aulas aula[100])
{

  int p1 = calcula_penalidade(tabelaS0,capacidade,i1,j1,pexcesso,pociosidade,aula);
  int p2 = calcula_penalidade(tabelaS0,capacidade,i2,j2,pexcesso,pociosidade,aula);
  return p1+p2;
}


//------------------------------------------------------------------------------
//                           Funo Cria Matriz
//------------------------------------------------------------------------------
int **cria_matriz(int nlinhas, int ncolunas)
{
  register int i;
  int **matriz;

  matriz = (int **) malloc(nlinhas*sizeof(int *));
  if (!matriz) {
        printf("Falta memoria para alocar a matriz de ponteiros\n");
        exit(1);
  }
  for (i=0; i < nlinhas; i++) {
    matriz[i] = (int *) malloc(ncolunas*sizeof(int));
    if (!matriz[i]){
      printf("Falta memoria para alocar a matriz de ponteiros.\n");
      exit(1);
    }
  }
  return matriz;
}
//******************************************************************************

//int calcula_penalidade(int **p)

int calcula_penalidade(int tabelaS0[91][8],int *capacidade,int i,int j,int pexcesso,int pociosidade,aulas aula[100]){
        int aux;
        int penalidade;

        aux= tabelaS0[i][j];
        if (aula[aux].demanda> capacidade[j])
        {
            penalidade = pexcesso*(aula[aux].demanda- capacidade[j]);
        }
        else
        {
            penalidade = pociosidade*(capacidade[j]- aula[aux].demanda);
        }
return penalidade;
 }

